@echo Off
rem Copyright (C) The Organization for the Advancement of
rem Structured Information Standards [OASIS] (2002). All Rights Reserved.

rem This document and translations of it may be copied and furnished to
rem others, and derivative works that comment on or otherwise explain it or
rem assist in its implementation may be prepared, copied, published and
rem distributed, in whole or in part, without restriction of any kind,
rem provided that the above copyright notice and this paragraph are included
rem on all such copies and derivative works. However, this document itself
rem may not be modified in any way, such as by removing the copyright notice
rem or references to OASIS, except as needed for the purpose of developing
rem OASIS specifications, in which case the procedures for copyrights
rem defined in the OASIS Intellectual Property Rights document must be
rem followed, or as required to translate it into languages
rem other than English.

rem The limited permissions granted above are perpetual and
rem will not be revoked by OASIS or its successors or assigns.

rem This document and the information contained herein is provided on an
rem "AS IS" basis and OASIS DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
rem INCLUDING BUT NOT LIMITED TO ANY WARRANTY THAT THE USE OF THE INFORMATION
rem HEREIN WILL NOT INFRINGE ANY RIGHTS OR ANY IMPLIED WARRANTIES OF
rem MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

if not a%1 == a goto :gotarg
echo Missing the first argument naming the catalogue-specific documentation
echo copy batch file.
goto :done
:gotarg

if exist %1 goto :gotdocs
echo Missing "%1" for the catalogue-specific documentation files
goto :done
:gotdocs

rem Delete any pre-existing output files
if exist err-cat.xml del err-cat.xml

rem  Validate the exclusions and merge submission documents
call xml exclude.xml
call xml submits.xml

if exist result/nul rmdir /s /q result
mkdir result
mkdir result\support

echo Merging catalogues:
call xsl submits.xml ..\system\support\merge.xsl result\catalogue.xml
xcopy ..\system\support\collcat.dtd    result\support
xcopy ..\system\support\disc.dtd       result\support
xcopy ..\system\support\cfginfo.dtd    result\support
xcopy ..\system\support\exclinfo.dtd   result\support
xcopy ..\system\support\prose.dtd      result\support
xcopy ..\system\support\discinfo.dtd   result\support
xcopy ..\system\support\choices.dtd    result\support
xcopy ..\system\support\citation.dtd   result\support

rem  copy documentation files as required
call %1

xcopy ..\tests\*.* result /s

cd result
if exist \merged-catalogue.zip del \merged-catalogue.zip
call pack \merged-catalogue.zip *.*
cd ..
rmdir /s /q result
mkdir result
cd result
call unpack \merged-catalogue.zip
call xml catalogue.xml
cd ..

rem  End
:done